<style lang="less" scoped>
.search {
  position: relative;
  width: 30vw;
  &__input-block {
    display: flex;
    align-items: center;
  }
  &__input {
    z-index: 10;
    position: relative;
    width: 100%;
    display: flex;
    background-color: transparent;
    border-radius: 100px;
    border: 2px solid white;
    padding: 0.5rem 1rem;
    padding-right: 2.4rem;
    font-size: 1.3rem;
    outline: none;
    justify-content: center;
    align-items: center;
    transition: 0.3s all ease-in-out;
    &:focus {
      
    }
  }
  img {
    width: 1.4rem;
    margin-left: -2.2rem;
    height: auto;
  }
  &__results {
    position: absolute;
    width: 100%;
    .results__container {
      .first {
        background-color: #fff;
        border-bottom-left-radius: 50px;
      }
    }
  }
}
</style>

<template>
  <div class="search">
    <div class="search__input-block">
      <input class="search__input" />
      <img src="/icons/search.svg" alt />
    </div>
    <div class="search__results">
      <ul class="results__container">
        <li v-for="(result, id) of results" :key="id" class="results__item">{{ result.text }}</li>
      </ul>
    </div>
  </div>
</template>


<script>
import { debounceTime, filter, map } from 'rxjs/operators/'

export default {
  name: 'SearchBar',
  data: () => ({
    results: [
      {
        text: 'test'
      }
    ]
  }),
  mounted() {
    const onInput = this.$fromDOMEvent('.search__input input', 'input').pipe(
      map(event => event.target.value),
      filter(value => value.length > 1),
      debounceTime(300)
    )
    onInput.subscribe(async text => {
      // const { data } = await this.$http.get('/api/find/' + text)
      this.results = [
        {
          text: 'Moscow'
        },
        {
          text: 'Baranovichi'
        },
        {
          text: 'Saint-Peterburg'
        },
        {
          text: 'Minsk'
        },
        {
          text: 'Brest'
        }
      ]
    })
  },
  methods: {}
}
</script>
